var applet=null;
var certs=null;
var extensionAktiv=false;
var activeSites=new Array();
var focusedSite=null;
var internval;


/*Turn the extension on and off*/
function xxcv_switchMode(event){
if ( event.button === 0 ) {
	if(extensionAktiv==false){	/*aktivate extensoin, get all certificates, evaluate them and show infos in the tree view*/
		window.onclick=xxcv_activeWindowHandler;
		xxcv_changeContent();
		extensionAktiv=true;
		document.getElementById("img_cert").src="chrome://xxcv/content/images/cert_aktiv.png";
		interval=window.setInterval("xxcv_activeWindowHandler(null)",1000);
	}
	else{						/*deactivate extension, reload all pages with changed content*/
		extensionAktiv=false;
		window.clearInterval(interval);
		document.getElementById("img_cert").src="chrome://xxcv/content/images/cert_inactiv.png";
		window.onclick=undefined;
		for(var i=0;i<activeSites.length;i++){
			try{
				activeSites[i].reload();
			}catch(e){}
		}
		activeSites=new Array();
	}
	}
}

/*Change X509Certificate content in the treeview*/
function xxcv_changeContent(){
	certs=new Array();
	xxcv_extractCerts();
	
	focusedSite=window.top.getBrowser().selectedBrowser.contentWindow.location;
	var mainDocument=window.top.getBrowser().selectedBrowser.contentWindow.document;
	try{
		var anonymList=window.top.getBrowser().selectedBrowser.contentWindow.document.getAnonymousNodes(mainDocument.firstChild);
		if(anonymList.length>0){
			activeSites[activeSites.length]=window.top.getBrowser().selectedBrowser.contentWindow.location;
			xxcv_findElements(anonymList[0]);
	
			xxcv_openAppletWin();
			/*open invincible window that changes content, this is needed because loading the applet is asynchron, window is openend after applet loading has finished*/
			window.openDialog("chrome://xxcv/content/changeContent.xul", "Box","centerscreen, chrome, resizable, dependent",certs,applet,mainDocument);
		}
	}catch(e){}
}

/*Open info window with details about all certificates in the XML-file*/
function xxcv_openInfoBox(){
	certs=new Array();
	xxcv_extractCerts();
	var mainDocument=window.top.getBrowser().selectedBrowser.contentWindow.document;
	try{
		var anonymList=window.top.getBrowser().selectedBrowser.contentWindow.document.getAnonymousNodes(mainDocument.firstChild);
		xxcv_findElements(anonymList[0]);
	
		xxcv_openAppletWin();
		window.openDialog("chrome://xxcv/content/infobox.xul", "Box","centerscreen, chrome, resizable, dependent",certs,applet);
	}catch(e){/*No XML file ==>do nothing*/}
}

function xxcv_openX509Preferences(){
	window.openDialog("chrome://xxcv/content/x509preferences.xul", "Preferences","centerscreen, modal, toolbar, titlebar, chrome, resizable, dependent");
}

/*Open applet window. This applet reads in the certificate and returns information about it. It is also needed to bootstrap the java plugin*/
function xxcv_openAppletWin(){
	if(applet==null){
		applet=window.openDialog(xxcv_getExtensionPath("xxcv")+"chrome/content/applet.html","","chrome, dependent, centerscreen, close=no");
		setTimeout("xxcv_moveWindow()",1000);	/*hide applet window*/
	}
} 


/*Hide applet window*/
function xxcv_moveWindow(){
	applet.resizeTo(0,0);		/*hides window in Linux*/
	applet.moveTo(-500,-500);	/*hides window in Windows*/
}

/*get all certificates from the current document and safe them to the array certs*/
function xxcv_extractCerts(){
	var nodes, node,certificate;
	nodes = window.top.getBrowser().selectedBrowser.contentWindow.document.evaluate("//*", window.top.getBrowser().selectedBrowser.contentWindow.document, null, XPathResult.UNORDERED_NODE_SNAPSHOT_TYPE, null);
	var j=0;
	for (var i = 0; i < nodes.snapshotLength; i++) { 
		node = nodes.snapshotItem(i);
		if(node != null && node.nodeName.endsWith('X509Certificate'))
		{  
			certificate = node.firstChild.data;
			certs[j]=new Object();
			certs[j]["cert_orig"]=node.firstChild.data;
			certs[j]["cert"]=node.firstChild.data.replace(/ /g,"");;
			var begin=certs[j]["cert"].substring(0,27);
			/*if(begin!="-----BEGIN CERTIFICATE-----"){	TODO: Kann "BEGIN CERTIFICATE vorkommen?*/
				certs[j]["cert"]="-----BEGIN CERTIFICATE-----\n"+certs[j]["cert"]+"\n-----END CERTIFICATE-----\n";
			/*}  geht nicht, weil .replace das Leerzeichen loescht*/
			j++;
		}
	}
}

/*Find the nodes from the anonymous content of the tree view that correspond to the certificates from the array certs. This is needed to change their content.
Variable index is for code optimation perpose. It saves the index of the next certificate to find, so that searching should always find the next one first*/
var index=0;
function xxcv_findElements(node){
	if(node.nodeName=="span" && node.textContent.endsWith("X509Certificate")){
		try{
			for(var j=0;j<certs.length;j++){
				if(node.nextSibling.nextSibling.textContent==certs[((j+index)%certs.length)]["cert_orig"]){
					certs[((j+index)%certs.length)]["element"]=node.nextSibling.nextSibling;
					break;
				}
			}
			index++;
		}catch(e){}
	}
	var childs=node.childNodes;
	for(var i=0;i<childs.length;i++){
		xxcv_findElements(childs[i]);
	}
}

/*Get the absolute location of the extension folder on disc*/
function xxcv_getExtensionPath(extensionName) {
    var chromeRegistry =
        Components.classes["@mozilla.org/chrome/chrome-registry;1"]
            .getService(Components.interfaces.nsIChromeRegistry);
            
    var uri =
        Components.classes["@mozilla.org/network/standard-url;1"]
            .createInstance(Components.interfaces.nsIURI);
    
    uri.spec = "chrome://" + extensionName + "/content/";
    
    var path = chromeRegistry.convertChromeURL(uri);
    if (typeof(path) == "object") {
        path = path.spec;
    }
    
    path = path.substring(0, path.indexOf("/chrome/") + 1);

    return path;
}

/*Search array and find out, if the content has yet been changed*/
function xxcv_contentChanged(site){
	for(var i=0;i<activeSites.length;i++){
		if(activeSites[i]==site){
			return true;
		}
	}
	return false;
}

/*IDEE: Wenn UrlChangedEvent nicht abgefangen werden kann==>diese Methode regelmig aufrufen*/
/*Alternativ: KeyEvent abfangen und Enter raussuchen*/
function xxcv_activeWindowHandler(event){
	if(extensionAktiv){
		if(focusedSite!=window.top.getBrowser().selectedBrowser.contentWindow.location){
			if(!xxcv_contentChanged(window.top.getBrowser().selectedBrowser.contentWindow.location)){
				xxcv_changeContent();
			}
		}
	}
}

/*Add function "endsWith" to the class String*/
String.prototype.endsWith = function(txt)
{
  var rgx = new RegExp(txt+"$");
  return this.match(rgx)!=null; 
}
